/*================================================================
    DLA(Diffusion Limitted Aggregation, $B3H;6N'B.6E=8(B) 
=================================================================*/    

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <XRS/Control.h>
#include <XRS/Graphic.h>

#define PI         M_PI
#define RAN        (drand48()<0.5 ? -1:1)   // -1,1 $B$r%i%s%@%`$K=P$9(B


/************** $BBg0hJQ?t$H4X?t@k8@(B ********************/

int      **site;
double   **jump;
int      n;                // $B6E=8$7$?N3;R?t(B
int      x,y;              // $B3H;6N3;R$N0LCV(B
int      N;                // $B3J;R$N%5%$%:$NH>J,(B
int      rr0=0;            // $B6E=8BN$r:n$kN3;R$N:GBgH>7B(B
double   r1;               // $BN3;R$N=PH/E@$NH>7B(B
int      rr2;              // $BH>7B$,(Bsqrt(rr2)$B0J>e$K$J$C$?$i3H;6N3;R$r<h$j=|$/!#(B
double   initial_jump=10;  // $B<~$j$K6E=8BN$,$J$$NN0h$G$N(B1$BJb$NI}(B


void       initial(int);
int        setR(int);
void       stick(int,int);
inline int RR(int x,int y){ int i=x-N,j=y-N; return i*i+j*j;} //$BCf?4$+$i$N5wN%(B
inline double R(int x,int y,int x0,int y0){    // (x,y),(x0,y0) $B$N5wN%(B
            int i=x-x0,j=y-y0;  return sqrt(double(i*i+j*j)); }


/*---------------- $B0J2<(B XWindow $BMQ(B --------------------*/
Control_Window CW;
Graphic_Window Lattice;

void            explain(int)
{  if(!fork()){ execlp("xdvi","xdvi","-s","8","README_DLA.dvi",0);}  }


int main(int argc,char **argv)
{
   int      rr;           // $B3H;6N3;R$NCf?4$+$i$N5wN%$NFs>h(B
   int      nn;           // =(N-1)*(N-1)
   double   r;

   /*--------------- initialize ---------------------*/
   
   if(argc>1) N=atoi(argv[1]); else N=200;
   fprintf(stderr,"usage%% DLA [N]\n"
	  " current systemsize=2*N: N=%d\n",N); 
   
   nn=(N-1)*(N-1);
   array(site,2*N,2*N);
   array(jump,2*N,2*N);

/*----- initialize ----------*/
   
   CW.realtime=0;
       f_dialog d(CW,explain);
       d.resize(2*d.width(),d.height());
       d.string(20);
       d.title(" readme (Click here)");
   CW.realtime=1;

   CW<<n<<"n"<<initial<<"initial";
   Lattice.geometry(2*N,2*N,1)<<"DLA";
   initialize();

/*----- main routine --------*/
   
   initial(0);

   double theta;
   while(1){
      checkevent();
      // $BN3;R$r#1$D:n$k!#(B
      theta=2*PI*drand48();
      x=int(r1*cos(theta)+(double)N+0.5);
      y=int(r1*sin(theta)+(double)N+0.5);
      n++;
      
      while(1){
         theta=2*M_PI*drand48();
         r=jump[x][y]; 
	 if(r>2){   // $BJbI}(B r $B$N%i%s%@%`%&%)!<%/(B
   	   x=int((double)x+0.5+r*cos(theta));
	   y=int((double)y+0.5+r*sin(theta));
	 }else{     // 1$B3J;RJ,$N%i%s%@%`%&%)!<%/(B
           x+=RAN; y+=RAN;	   
	 }
	                 
         rr=RR(x,y);
         if(rr>rr2){ n--; break;}  // $B1s$/$K$J$j2a$.$?$i!"<h$j=|$/!#(B
         if(rr<nn){ 
            if(site[x+1][y]+site[x-1][y]+site[x][y+1]+site[x][y-1]){
               stick(x,y);    // $BNY@\3J;RE@$KN3;R$,$"$C$?$i!"$/$C$D$/!#(B
               break;
            }
         }
      }
      if(nn<rr2) initial(0);
   }
}   


/***************** $B=i4|>r7o(B **************************/

void initial(int nn){
   int i,j;
   Lattice.clear();
   for(i=0; i<2*N; i++)
     for(j=0; j<2*N; j++){ site[i][j]=0;  jump[i][j]=initial_jump;}
   rr0=-1;  n=0;
   setR(0);
   
   switch(nn){
   case 2:
     for(i=0; i<2*N; i++)
       for(j=0; j<2*N; j++){
	 if(RR(i,j)<(N*N)/16){ stick(i,j); n++;}
       } break;
   case 3:
     stick(N-N/8,N); n++;
     stick(N+N/8,N); n++;
     break;
   default:				  
     stick(N,N); n++;
   }
}


/************* rr0,r1,r2,rr2 $B$NJQ99(B ********************/

int        setR(int rr){ 
   if(rr>=rr0){  
      double  r0;
      int     r2; 
      rr0=rr; r0=sqrt((double)rr);
      r1=(double)(1+r0);
      r2=(int)(initial_jump+r1); rr2=r2*r2;
      return 1;  
   }
   return 0;
}


/************* $B6E=8$N%W%m%;%9(B ********************/

#define min(x,y)  ((x)<(y)?(x):(y))
#define max(x,y)  ((x)>(y)?(x):(y))

void  stick(int x,int y){
   int    i,j;
   double rr;
   
   site[x][y]=1;
   setR(RR(x,y));   
   Lattice.draw_point(1,x,y);
   for(i=max(0,x-(int)initial_jump); i<min(2*N,x+(int)initial_jump); i++)
       for(j=max(0,y-(int)initial_jump); j<min(2*N,y+(int)initial_jump); j++){
	   rr=R(i,j,x,y);
	   if(rr<jump[i][j]) jump[i][j]=rr;
       }
}  
