/*=================================================================
    FitzHugh-$BFn1@(B $BJ}Dx<0(B

    $B&E(Bu'=u(1-u)(u-a)-v
      v'=u
=================================================================*/

/*************************************************************
    $B%$%s%/%k!<%I$HBg0hJQ?t(B
*************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
#include <ode.h>

double ep=0.1,a=0.1;
double *xp,**yp,dxsav,xx=0,yy=0.1;
int    kmax,kount;


/*************************************************************
    $B%0%i%U%#%C%/MQ$N%$%s%/%k!<%I$HJQ?t!"4X?t$N@k8@(B
*************************************************************/

#include <XRS/Control.h>
#include <XRS/Plane.h>

#define WinI(x)  (int)((double)width*(0.5+Amp*(x)))
#define WinJ(x)  (int)((double)height*(0.5-Amp*(x)))
#define WinX(i)  (double)(((double)i/width-0.5)/Amp)
#define WinY(j)  (double)((0.5-(double)j/height)/Amp)


double         Amp=0.4;
int            height=500,width=500,marker=1,nmax=500,slow=200000;
Plane_Window   Win;
Control_Window CW,SubCW(Win);
void           draw();
void           startpoint(int);
void           nullcline();
void           explain(int)
{  if(!fork()){ execlp("xdvi","xdvi","-s","8","README_FitzHughNagumo.dvi",0);}  }


/************************************************************
    $BJ}Dx<0(B
*************************************************************/

void derivs(double x,double y[],double dydx[]){
    double u=y[1],v=y[2];
    dydx[1]=(u*(1.0-u)*(u-a)-v)/ep;
    dydx[2]= u;
}



/************************************************************
    $B%a%$%s%k!<%A%s(B
*************************************************************/

int main(int argc,char *argv[])
{
    int nvar=2;  // $BJ}Dx<0$NJQ?t$N?t(B
    int nok,nbad;
    double x1,x2,eps,h1,hmin,hmax;
    double *ystart=vector(1,nvar);
    
    /*----- $B%&%$%s%I%&$N=i4|@_Dj(B ---------*/

    CW.realtime=0;
    f_dialog d(CW,explain);
    d.resize(2*d.width(),d.height());
    d.string(20);
    d.title(" readme (Click here)");
    CW.realtime=1;
    
    CW<<PARAMETER<<"ep"<<ep<<a<<"a"<<"Amp"<<Amp
      <<"nmax"<<nmax<<"slow"<<slow;
    
    Win.geometry(width,height)
	<<"FitzHugh Nagumo equation (crick this window! )"<<startpoint;
    SubCW<<"x0"<<xx<<"y0"<<yy;
    
    initialize();
    nullcline();          

    /*----- $B%Q%i%a!<%?$,JQ99$5$l$k$?$S$K2r$-D>$9!#(B ---------*/

    while(1){
	
      ystart[1]=xx;  // $B=i4|>r7o(B
      ystart[2]=yy;

      x1=0;          // $B=i4|;~9o(B
      x2=1000;       // $B=*N;;~9o(B
      eps=0.00001;   // $B@:EY(B
      h1=0.01;       // $B=i4|$N9o$_I}(B
      hmin=0.0;      // $B9o$_I}$N:G>.CM(B
      hmax=0.1;      // $B9o$_I}$N:GBgCM(B
      kmax=10000;    // $BG[Ns$NBg$-$5(B
      dxsav=0.01;    
	
      xp=vector(1,kmax);
      yp=matrix(1,nvar,1,kmax);

      // $BE,1~9o$_I}@)8f$D$-$N%k%s%2%/%C%?K!(B
      odeint(ystart,nvar,x1,x2,eps,h1,hmin,hmax,&nok,&nbad,derivs,rkqs);

      // $BIA2h(B
      draw();

      // $B%$%Y%s%HH/@8$r8!=P$9$k$^$GBT$D!#(B
      Win.chev=CW.chev=0;
      while(!CW.chev && !Win.chev ) checkevent();
      nullcline();      
      CW.draw();
    }
}



/************************************************************
     $BIA2h(B
*************************************************************/

void draw_mark(int,int,int,int);
void erase_mark(int,int,int,int);
	
void draw()
// $B7k2L$NI=<((B 
{
   static int initial=1;
   int    i0,j0,i,j;

   if(initial){ // $B:BI8<4(B
       Win.draw_line(2,WinI(0.0),0,WinI(0.0),height); 
       Win.draw_line(2,0,WinJ(0.0),width,WinJ(0.0));
       initial=0;
   }

   Win.clear(0); 
   Win.clear(1);
   
   i0=WinI(yp[1][1]); j0=WinJ(yp[2][1]);
   for(int n=2; n<kount; n++){ 
       if(marker && n>nmax) break;       
       i=WinI(yp[1][n]); j=WinJ(yp[2][n]);
       if(marker){ // $B%H%l!<%5!<IU$-(B
	   for(int m=0; m<slow; m++); // $B<B9T$rCY$i$;$k$?$a$N%k!<%W(B
	   erase_mark(0,i0,j0,5);
	   draw_mark(0,i,j,5);
       }	   
       Win.draw_line(1,i0,j0,i,j);    // $B50@W$NIA2h(B
       i0=i; j0=j;
   }
}    


void nullcline()
// $B%L%k%/%i%$%s$NIA2h(B
{
   double u;
   int    j,j1=0,i0=0;
   Win.clear(4);   
   for(int i=1; i<width; i++){
       u=WinX(i);
       j=WinJ(u*(1-u)*(u-a));
       Win.draw_line(4,i0,j1,i,j); j1=j; 
       i0=i;
   }       
}    


void draw_mark(int c,int x,int y,int r)
// $B%&%#%s%I%&(B Win $B$K?'(B c $B$G(B $BCf?4(B(i,j) $BH>7B(B r $B$NEI$j$D$V$5$l$?1_$r=q$/!#(B
{
    for(int i=-r; i<r+1; i++)
	for(int j=-r; j<r+1; j++)
	    if(i*i+j*j<=r*r) Win.draw_point(c,i+x,j+y);
}


void erase_mark(int c,int x,int y,int r)
// $B%&%#%s%I%&(B Win $B$K?'(B c $B$N(B $BCf?4(B(i,j) $BH>7B(B r $B$NEI$j$D$V$5$l$?1_$r>C$9!#(B
{    
    for(int i=-r; i<r+1; i++)
	for(int j=-r; j<r+1; j++)
	    if(i*i+j*j<=r*r) Win.erase_point(c,i+x,j+y);
}    


void   startpoint(int n)
// $B%^%&%9$,2!$5$l$?0LCV$N:BI8$r=i4|E@$H$9$k!#$^$?!"1&%\%?%s$,2!$5$l$?$i!"(B
// $BI=<(%b!<%I$rJQ99$9$k!#(B
{
    xx=WinX(Win.ev.xbutton.x);
    yy=WinY(Win.ev.xbutton.y);
    if(n==3) marker=!marker; 
}    
