/*=================================================================
    R\"ossler $BJ}Dx<0(B

    dxdt=-y-z;
    dydt=x+a*y;
    dzdt=b-c*z+x*z;
=================================================================*/

/*************************************************************
    $B%$%s%/%k!<%I$HBg0hJQ?t(B
*************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
#include <ode.h>          // $B>oHyJ,J}Dx<0$r2r$/%5%V%k!<%A%s(B
#include <project.h>      // 3$B<!85$NE@$rJ?LL$K<M1F$9$k%5%V%k!<%A%s(B

double a=0.2,b=0.2,c=5.8;
double *xp,**yp,*x,*y,dxsav,xx=0,yy=0.1,zz=0.0;
int    kmax,kount;


/*************************************************************
    $B%0%i%U%#%C%/MQ$N%$%s%/%k!<%I$HJQ?t!"4X?t$N@k8@(B
*************************************************************/

#include <XRS/Control.h>
#include <XRS/Plane.h>

#define WinI(x)  (int)((double)width*(0.5+Amp*(x)))
#define WinJ(x)  (int)((double)height*(0.5-Amp*(x)))
#define WinX(i)  (double)(((double)i/width-0.5)/Amp)
#define WinY(j)  (double)((0.5-(double)j/height)/Amp)

double         Amp=0.02;
int            height=500,width=500,marker=1,nmax=500,slow=200000;
axis           axy;    
double         theta=-0.2,phi=0.1;
Plane_Window   Win;
Control_Window CW,SubCW(Win);
void           draw();
void           startpoint(int);
void           explain(int)
{  if(!fork()){ execlp("xdvi","xdvi","-s","8","README_Rossler.dvi",0);}  }


/************************************************************
    $BJ}Dx<0(B
*************************************************************/

void derivs(double x,double y[],double dydx[]){
    double X=y[1],Y=y[2],Z=y[3];
    dydx[1]= -Y-Z;
    dydx[2]= X+a*Y;
    dydx[3]= b-c*Z+X*Z;
}


/************************************************************
    $B%a%$%s%k!<%A%s(B
*************************************************************/

int main(int argc,char *argv[])
{
    int nvar=3;  // $BJ}Dx<0$NJQ?t$N?t(B
    int nok,nbad;
    double x1,x2,eps,h1,hmin,hmax;
    double *ystart=vector(1,nvar);

    /*----- $B%&%$%s%I%&$N=i4|@_Dj(B ---------*/

    CW.realtime=0;
    f_dialog d(CW,explain);
    d.resize(2*d.width(),d.height());
    d.string(20);
    d.title(" readme (Click here)");
    CW.realtime=1;
    
    CW<<PARAMETER<<"a"<<a<<b<<"b"<<c<<"c"<<theta<<"theta"<<phi<<"phi"
                 <<"Amp"<<Amp
      <<"nmax"<<nmax<<"slow"<<slow;
    
    Win.geometry(width,height)
	<<"Roessler equation (crick this window! )"<<startpoint;
    SubCW<<"x0"<<xx<<"y0"<<yy<<PARAMETER<<"z0"<<zz;
    
    initialize();

    /*----- $B%Q%i%a!<%?$,JQ99$5$l$k$?$S$K2r$-D>$9!#(B ---------*/

    while(1){
	
      ystart[1]=xx;  // $B=i4|>r7o(B
      ystart[2]=yy;
      ystart[3]=zz;

      x1=0;          // $B=i4|;~9o(B
      x2=1000;       // $B=*N;;~9o(B
      eps=0.00001;   // $B@:EY(B
      h1=0.01;       // $B=i4|$N9o$_I}(B
      hmin=0.0;      // $B9o$_I}$N:G>.CM(B
      hmax=0.1;      // $B9o$_I}$N:GBgCM(B
      kmax=10000;    // $BG[Ns$NBg$-$5(B
      dxsav=0.01;    
	
      xp=vector(1,kmax);
      yp=matrix(1,nvar,1,kmax);

      // $BE,1~9o$_I}@)8f$D$-$N%k%s%2%/%C%?K!(B
      odeint(ystart,nvar,x1,x2,eps,h1,hmin,hmax,&nok,&nbad,derivs,rkqs);

      // $BF@$i$l$?E@$rJ?LL$K<M1F$9$k!#(B
      x=new double [kount-1];
      y=new double [kount-1];
      axy=project(theta,phi,kount-1,
                  &yp[1][1],&yp[2][1],&yp[3][1],x,y);

      // $BIA2h(B
      draw();

      // $B%$%Y%s%HH/@8$r8!=P$9$k$^$GBT$D!#(B
      Win.chev=CW.chev=0;
      while(!CW.chev && !Win.chev ) checkevent();
      CW.draw();
   
      delete [] x;
      delete [] y;
    }
}



/************************************************************
     $BIA2h(B
*************************************************************/

void draw_mark(int,int,int,int);
void erase_mark(int,int,int,int);
	
void draw()
// $B7k2L$NI=<((B 
{
   int    i0,j0,i,j;

   Win.clear(0); 
   Win.clear(1);
   Win.clear(2); 

   for(int k=0; k<3; k++){
     Win.draw_line(2,WinI(axy.x[0][k]),WinJ(axy.y[0][k]),
                     WinI(axy.x[1][k]),WinJ(axy.y[1][k])); 
   }

   i0=WinI(x[0]); j0=WinJ(y[0]);
   for(int n=1; n<kount-1; n++){ 
       if(marker && n>nmax) break;       
       i=WinI(x[n]); j=WinJ(y[n]);
       if(marker){ // $B%H%l!<%5!<IU$-(B
	   for(int m=0; m<slow; m++); // $B<B9T$rCY$i$;$k$?$a$N%k!<%W(B
	   erase_mark(0,i0,j0,5);
	   draw_mark(0,i,j,5);
       }	   
       Win.draw_line(1,i0,j0,i,j);    // $B50@W$NIA2h(B
       i0=i; j0=j;
   }
}    


void draw_mark(int c,int x,int y,int r)
// $B%&%#%s%I%&(B Win $B$K?'(B c $B$G(B $BCf?4(B(i,j) $BH>7B(B r $B$NEI$j$D$V$5$l$?1_$r=q$/!#(B
{
    for(int i=-r; i<r+1; i++)
	for(int j=-r; j<r+1; j++)
	    if(i*i+j*j<=r*r) Win.draw_point(c,i+x,j+y);
}


void erase_mark(int c,int x,int y,int r)
// $B%&%#%s%I%&(B Win $B$K?'(B c $B$N(B $BCf?4(B(i,j) $BH>7B(B r $B$NEI$j$D$V$5$l$?1_$r>C$9!#(B
{    
    for(int i=-r; i<r+1; i++)
	for(int j=-r; j<r+1; j++)
	    if(i*i+j*j<=r*r) Win.erase_point(c,i+x,j+y);
}    


void   startpoint(int n)
// $B%^%&%9$,2!$5$l$?0LCV$N:BI8$r=i4|E@$H$9$k!#$^$?!"1&%\%?%s$,2!$5$l$?$i!"(B
// $BI=<(%b!<%I$rJQ99$9$k!#(B
{
    projected_point P;
    double wx,wy;
    wx=WinX(Win.ev.xbutton.x);
    wy=WinY(Win.ev.xbutton.y);

    P=project_xytoXY(theta,phi,zz,wx,wy);
    xx=P.X;
    yy=P.Y;

    if(n==3) marker=!marker; 
}    
